#ifndef CLIB_PROGARGS_PROTOS_H
#define CLIB_PROGARGS_PROTOS_H
 
#ifndef LIBRARIES_PROGARGS_H
#include <libraries/progargs.h>
#endif
 
// =====================================================
// 2.x/3.x POOL FUNCTIONS
// =====================================================

APTR PA_AllocPooled( APTR poolHeader, unsigned long memSize );
APTR PA_CreatePool( unsigned long memFlags, unsigned long puddleSize,
                    unsigned long threshSize );
void PA_DeletePool( APTR poolHeader );
void PA_FreePooled( APTR poolHeader, APTR memory, unsigned long memSize );

APTR PA_AllocVecPooled( APTR poolHeader, ULONG memSize );
void PA_FreeVecPooled( APTR poolHeader, APTR memory );

// =====================================================
// TAG ARGUMENT FUNCTIONS
// =====================================================

void PA_FreeTagArgs( struct TagArgs* base );
struct TagArgs* PA_AllocTagArgsA( struct TagItem* controlTags );
struct TagArgs* PA_AllocTagArgs( Tag ctrl1Tag, ... );

BOOL PA_AddTagArgsA( struct TagArgs* base,struct TagItem* args );
BOOL PA_AddTagArgs( struct TagArgs* base,Tag arg1Tag, ... );

BOOL PA_RemTagArgsA( struct TagArgs* base,struct TagItem* args );
BOOL PA_RemTagArgs( struct TagArgs* base,Tag arg1Tag, ... );

// =====================================================
// PROGRAM ARGUMENT FUNCTIONS
// =====================================================

void FreeProgArgs( struct ProgArgs* progArgs );
struct ProgArgs* AllocProgArgsA( struct ArgEntry* entries, struct TagItem* cmdTags );
struct ProgArgs* AllocProgArgs( struct ArgEntry* entries, Tag cmd1Type, ... );

BOOL ExecProgArgsA( struct ProgArgs* progArgs, struct TagItem* cmdTags );
BOOL ExecProgArgs( struct ProgArgs* progArgs, Tag cmd1Type, ... );

BOOL AddProgArgsA( struct ProgArgs* progArgs, struct TagItem* argTags );
BOOL AddProgArgs( struct ProgArgs* progArgs, Tag arg1Type, ... );
BOOL RemProgArgsA( struct ProgArgs* progArgs, struct TagItem* argTags );
BOOL RemProgArgs( struct ProgArgs* progArgs, Tag arg1Type, ... );
BOOL GetProgArgsA( struct ProgArgs* progArgs, struct TagItem* argTags );
BOOL GetProgArgs( struct ProgArgs* progArgs, Tag arg1Type, ... );

struct ArgEntry* PA_GetArgEntry( struct ProgArgs* progArgs, Tag entryID );
struct ArgEntry* PA_NextArgEntry( struct ProgArgs* progArgs, 
                                  struct ArgEntry* curEntry );

#if 0

// =====================================================
// PROGRAM ARGUMENT TRANSLATOR FUNCTIONS
// =====================================================

struct ProgArgTrans* AllocProgArgTrans( struct Hook* MsgFunc,
                                        struct TagItem* tagItems );
struct ProgArgTrans* AllocProgArgTransA( struct Hook* MsgFunc,
                                         Tag tag1Type, ... );
void FreeProgArgTrans( struct ProgArgTrans* Translator );

BOOL PutProgArgsA( struct ProgArgs* Handle, struct ProgArgTrans* Translator,
                   struct TagItem* UserTags );
BOOL PutProgArgs( struct ProgArgs* Handle, struct ProgArgTrans* Translator,
                  Tag usr1Type, ... );
BOOL GetProgArgsA( struct ProgArgs* Handle, struct ProgArgTrans* Translator,
                   struct TagItem* UserTags );
BOOL GetProgArgs( struct ProgArgs* Handle, struct ProgArgTrans* Translator,
                  Tag usr1Type, ... );
#endif

#endif
